<?php

/* 
 * irmp3cmd.php - the script for sending a comand to irmp3
 *
 * Copyright (c) by Andreas S. Krebs (andreas.krebs@web.de)
 *
 * when done this script calls current.php to display the current song.
 *
 */

require_once("config.inc");
require_once("irmp3.inc");
require_once("utils.inc");
require_once("dbqueryentries.inc");

disable_caching();

$modecmd=array();
if(isset($repeat))
  $modecmd[]="playlist repeat $repeat";
if(isset($shuffle))
  $modecmd[]="playlist shuffle $shuffle";

$comand=str_replace(">", "+", $comand);		// special rule for IE4 since no escaping of + seems possible :-(
$cmd=false;
if($comand == "play")
{
  // why is ` still escaped, is this a bug or a feature of php?
  $file=str_replace("\'", "'", $file);
  $file=str_replace("\`", "`", $file);

  $cmd=array("play $file", "query shuffle", "query repeat");
  $answers=array("play", "time", "shuffle", "repeat");
}
else if($comand == "stop")
{
  $cmd=array("stop", "query shuffle", "query repeat");
  $answers=array("shuffle", "repeat");
}
else if($comand == "playsel")
{
  include("selentries.inc");	// get the selected entries from session
  $entryFiles=queryEntries("", $selEntries);

  $listname=tempnam($TEMP_M3UDIR, "muwed_");
  createPlayList($listname, $MP3ROOT, $entryFiles);

  $cmd=array("playlist load $listname", "query shuffle", "query repeat");
  $answers=array("play", "time", "shuffle", "repeat");
}
else if($comand == "playpl")
{
  if(strlen($playlist)>0)
  {
    // why is ` still escaped, is this a bug or a feature of php?
    $playlist=str_replace("\'", "'", $playlist);
    $playlist=str_replace("\`", "`", $playlist);
  }
  else	// no file existing, so we have to create a temporary one
  {
    $entryFiles=queryEntries(getPlaylistEntriesClause($plid), false);

    $playlist=tempnam($TEMP_M3UDIR, "muwed_");
    createPlayList($playlist, $MP3ROOT, $entryFiles);
  }

  $cmd=array("playlist load $playlist", "query shuffle", "query repeat");
  $answers=array("play", "time", "shuffle", "repeat");
}
else if($comand != false && $comand != "refresh")
{
  $cmd=array($comand, "query mp3file", "query status", "query time", "query shuffle", "query repeat");
  $answers=array("file", "status", "time", "shuffle", "repeat");
}

if($cmd!=false || count($modecmd)>0)
{
  if($cmd==false)
    $cmd=$modecmd;
  else if(count($modecmd)>0)
    $cmd=array_merge($modecmd, $cmd);

  $irmp3_info=irmp3_cmd($IRMP3_HOST, $IRMP3_PORT, $cmd, $answers);
}


// now use current.php to display the current song
include("current.php");

function createPlayList($listname, $rootdir, $listEntries)
{
  $fh=fopen($listname, "w");

  if($fh==false)
    echo("failed to play list \"$listname\" for writing");
  else
  {
    for($i=0; $i<count($listEntries); $i++)
    {
      fputs($fh, $rootdir.$listEntries[$i]."\n");
    }

    fclose($fh);
  }
}

?>
