<?php

/* 
 * queryform.inc - the script to display the query form and set default values. 
 *
 * Copyright (c) by Andreas S. Krebs (andreas.krebs@web.de)
 *
 */

require_once("config.inc");

function createQueryField_TABLE()
{
  global $artist, $composer, $title, $album, $plid;
  global $match, $regex, $case, $addentries, $showsel, $sortby;
  global $ARTIST_SIZE, $COMPOSER_SIZE, $TITLE_SIZE, $ALBUM_SIZE, $PLID_SIZE, $SHOW_COLUMN, $HAS_JS;

  $regex=($regex === 0) ? 0 : 1;	// for regex default is true

  $eartist=htmlspecialchars($artist);
  $ecomposer=htmlspecialchars($composer);
  $etitle=htmlspecialchars($title);
  $ealbum=htmlspecialchars($album);
  $eplid=htmlspecialchars($plid);

  $table1=new TABLEtag(array("WIDTH"=>"100%"));

  $table2=new TABLEtag(array("WIDTH"=>"100%"));
  $table2->push_row(
      create_TD(array("CLASS"=>"Name", "ALIGN"=>"MIDDLE"), array("muwed", html_a("search.php", "search song"), " / ", html_a("plsearch.php", "search playlist"))),
      create_TD(array("CLASS"=>"Display", "ALIGN"=>"MIDDLE"), html_b(html_a("searchhelp.php", "help", NULL, "search_help"))));

  $fieldsTD=create_TD(array("CLASS"=>"Display", "ALIGN"=>"MIDDLE"));

  if($SHOW_COLUMN["artist"])
    $fieldsTD->push("Artist:", form_text("artist", "$eartist", "$ARTIST_SIZE"));

  if($SHOW_COLUMN["composer"])
    $fieldsTD->push("Composer:", form_text("composer", "$ecomposer", "$COMPOSER_SIZE"));

  if($SHOW_COLUMN["title"])
    $fieldsTD->push("Title:", form_text("title", "$etitle", "$TITLE_SIZE"));

  if($SHOW_COLUMN["album"])
    $fieldsTD->push("Album:", form_text("album", "$ealbum", "$ALBUM_SIZE"));

  $fieldsTD->push("Playlist ID: #", form_text("plid", "$eplid", "$PLID_SIZE"));

  $matchsel=($match == "AND") ? "ALL" : "ANY";
  $regexattr=($regex == 1) ? array("CHECKED") : array();
  $caseattr=($case == 1) ? array("CHECKED") : array();
  $addentattr=($addentries == 1) ? array("CHECKED") : array();
  $showselattr=($showsel == 1) ? array("CHECKED") : array();

  $resetInp=array();
  if($HAS_JS)
  {
    $onclk="javascript: document.qform.plid.value='';";

    if($SHOW_COLUMN["artist"])
      $onclk.=" document.qform.artist.value='';";

    if($SHOW_COLUMN["composer"])
      $onclk.=" document.qform.composer.value='';";

    if($SHOW_COLUMN["title"])
      $onclk.=" document.qform.title.value='';";

    if($SHOW_COLUMN["album"])
      $onclk.=" document.qform.album.value='';";

    $resetInp=form_button("Reset", "Reset", array("ONCLICK"=>$onclk));
  }

  $table2->push_row(
      $fieldsTD,
      create_TD(array("CLASS"=>"Display", "ALIGN"=>"MIDDLE"), form_submit("Search", "Search")));

  $table2->push_row(
      create_TD(array("CLASS"=>"Display", "ALIGN"=>"MIDDLE"), array(
        "Match:", form_select("match", array("ALL"=>"AND", "ANY"=>"OR"), $matchsel),
        form_checkbox("regex", "1", $regexattr), "regex",
        form_checkbox("case", "1", $caseattr), "case sensitive",
        form_checkbox("addentries", "1", $addentattr), "add to selection",
        form_checkbox("showsel", "1", $showselattr), "show selected",
        form_checkbox("clearlist", "1"), "clear selection",
        form_hidden("sortby", "$sortby"))),
      create_TD(array("CLASS"=>"Display", "ALIGN"=>"MIDDLE"), $resetInp));

  $table1->push_row(create_TD(array("CLASS"=>"Display", "ALIGN"=>"MIDDLE"), $table2));

  return $table1;
}
